-- Microsoft SQL Server - Scripting
-- Database: ReqPro
-- Creation 09/17/2009
-- Version: 1.00.0005
--
-- If the default Login and User schema has been used, then create all
-- objects under the ReqPro user.  Otherwise, create them under
-- the current Login.
--
-- History:
-- DATE         DEVELOPER(S)           VERSION   DESCRIPTION
-- 09/17/2009   Babar Abdul Qayyum     7.1       New set of tables, procedures and triggers to handle RRC syncronization
--              Bill Betz
--              Alex Chalini
--              Fabian Lomeli


Setuser
Go

-- ######### In case you are not using the default username value 'ReqPro',  please do a search and replace to specify the custom name, with search options: full word, case sensitive . ######### 
If Exists(select * from sysusers where uid = user_id('ReqPro'))
   Setuser 'ReqPro'
Go

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

SET ANSI_PADDING ON
GO




---- DROP TABLE CONSTRAINTS
--
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOG_RQTLOGOBJECTTYPE]') AND parent_object_id = OBJECT_ID(N'[RQTLOG]'))
--ALTER TABLE [RQTLOG] DROP CONSTRAINT [FK_RQTLOG_RQTLOGOBJECTTYPE]
--GO
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOG_RQTLOGTRANSTYPE]') AND parent_object_id = OBJECT_ID(N'[RQTLOG]'))
--ALTER TABLE [RQTLOG] DROP CONSTRAINT [FK_RQTLOG_RQTLOGTRANSTYPE]
--GO
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOGCOLUMNS_RQTLOG]') AND parent_object_id = OBJECT_ID(N'[RQTLOGCOLUMNS]'))
--ALTER TABLE [RQTLOGCOLUMNS] DROP CONSTRAINT [FK_RQTLOGCOLUMNS_RQTLOG]
--GO
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOGOVERFLOW_RQTLOGCOLUMNS]') AND parent_object_id = OBJECT_ID(N'[RQTLOGOVERFLOW]'))
--ALTER TABLE [RQTLOGOVERFLOW] DROP CONSTRAINT [FK_RQTLOGOVERFLOW_RQTLOGCOLUMNS]
--GO
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOGDOCUMENTS_RQTLOG]') AND parent_object_id = OBJECT_ID(N'[RQTLOGDOCUMENTS]'))
--ALTER TABLE [RQTLOGDOCUMENTS] DROP CONSTRAINT [FK_RQTLOGDOCUMENTS_RQTLOG]
--GO
--IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[FK_RQTLOG_RQTLOGPROPERTY]') AND parent_object_id = OBJECT_ID(N'[RQTLOGPROPERTY]'))
--ALTER TABLE [RQTLOGPROPERTY] DROP CONSTRAINT [FK_RQTLOG_RQTLOGPROPERTY]
--GO
--
---- DROP TABLES
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOG]') AND type in (N'U'))
--DROP TABLE [RQTLOG]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGCOLUMNS]') AND type in (N'U'))
--DROP TABLE [RQTLOGCOLUMNS]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGOVERFLOW]') AND type in (N'U'))
--DROP TABLE [RQTLOGOVERFLOW]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGOBJECTTYPE]') AND type in (N'U'))
--DROP TABLE [RQTLOGOBJECTTYPE]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGTRANSTYPE]') AND type in (N'U'))
--DROP TABLE [RQTLOGTRANSTYPE]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGDOCUMENTS]') AND type in (N'U'))
--DROP TABLE [RQTLOGDOCUMENTS]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGMAP]') AND type in (N'U'))
--DROP TABLE [RQTLOGMAP]
--GO
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQTLOGPROPERTY]') AND type in (N'U'))
--DROP TABLE [RQTLOGPROPERTY]
--GO
--
--DROP VIEW RQTLOGV_MAPR 




-- ***** Object:  Table [RQTLOGOBJECTTYPE] *****
if not exists (select * from sysobjects where name='RQTLOGOBJECTTYPE' and xtype='U')
CREATE TABLE [RQTLOGOBJECTTYPE](
   [ID] [int] NOT NULL,
   [OBJECTTYPE] [varchar](20) NOT NULL,
 CONSTRAINT [PK_RQTLOGOBJECTTYPE] PRIMARY KEY CLUSTERED
(
   [ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO


-- ***** Object:  Table [RQTLOGTRANSTYPE] *****
if not exists (select * from sysobjects where name='RQTLOGTRANSTYPE' and xtype='U')
CREATE TABLE [RQTLOGTRANSTYPE](
   [ID] [int] NOT NULL,
   [TRANSTYPE] [varchar](20) NOT NULL,
 CONSTRAINT [PK_RQTLOGTRANSTYPE] PRIMARY KEY CLUSTERED
(
   [ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO




-- ***** Object:  Table [RQTLOG] *****
if not exists (select * from sysobjects where name='RQTLOG' and xtype='U')
CREATE TABLE [RQTLOG](
   [ID] [int] IDENTITY(1,1) NOT NULL,
   [PROJECTGUID] [varchar](40) NOT NULL,
   [PROJECTMAPID] [varchar](40) NULL,
   [USERID] [varchar](20) NOT NULL,
   [TDATE] [datetime] NOT NULL,
   [ISDOCUMENT] [bit] NOT NULL,
   [RQTTRANSTYPEID] [int] NOT NULL,
   [RQTOBJECTTYPEID] [int] NOT NULL,
   [RQTOBJECTGUID] [varchar](40) NOT NULL,
   [RQTEXTERNALID] [varchar](40) NULL,
 CONSTRAINT [PK_RQTLOG] PRIMARY KEY CLUSTERED
(
   [ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]

if not exists (select * from sysobjects where name='FK_RQTLOG_RQTLOGOBJECTTYPE' and xtype='F')
ALTER TABLE [RQTLOG] WITH CHECK ADD CONSTRAINT [FK_RQTLOG_RQTLOGOBJECTTYPE] FOREIGN KEY([RQTOBJECTTYPEID]) REFERENCES [RQTLOGOBJECTTYPE] ([ID])

if not exists (select * from sysobjects where name='FK_RQTLOG_RQTLOGTRANSTYPE' and xtype='F')
ALTER TABLE [RQTLOG] WITH CHECK ADD CONSTRAINT [FK_RQTLOG_RQTLOGTRANSTYPE] FOREIGN KEY([RQTTRANSTYPEID]) REFERENCES [RQTLOGTRANSTYPE] ([ID])
GO







-- ***** Object:  Table [RQTLOGCOLUMNS] *****
if not exists (select * from sysobjects where name='RQTLOGCOLUMNS' and xtype='U')
CREATE TABLE [RQTLOGCOLUMNS](
   [ID] [int] IDENTITY(1,1) NOT NULL,
   [RQTLOGID] [int] NOT NULL,
   [TABLENAME] [varchar](150) NOT NULL,
   [TID] [varchar](40) NOT NULL,
   [COLUMNNAME] [varchar](200) NOT NULL,
   [COLUMNVALUE] [varchar](4000) NULL,
   [ISOVERFLOW] [bit] NOT NULL,
 CONSTRAINT [PK_RQTLOGCOLUMNS] PRIMARY KEY CLUSTERED
(
   [ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]

if not exists (select * from sysobjects where name='FK_RQTLOGCOLUMNS_RQTLOG' and xtype='F')
ALTER TABLE [RQTLOGCOLUMNS] WITH CHECK ADD CONSTRAINT [FK_RQTLOGCOLUMNS_RQTLOG] FOREIGN KEY([RQTLOGID]) REFERENCES [RQTLOG] ([ID])
ON DELETE CASCADE
GO



-- ***** Object:  Table [RQTLOGOVERFLOW] *****
if not exists (select * from sysobjects where name='RQTLOGOVERFLOW' and xtype='U')
CREATE TABLE [RQTLOGOVERFLOW](
   [RQTLOGCOLUMNSID] [int] NOT NULL,
   [OVERFLOWTEXT] [text] NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

if not exists (select * from sysobjects where name='FK_RQTLOGOVERFLOW_RQTLOGCOLUMNS' and xtype='F')
ALTER TABLE [RQTLOGOVERFLOW] WITH CHECK ADD CONSTRAINT [FK_RQTLOGOVERFLOW_RQTLOGCOLUMNS] FOREIGN KEY([RQTLOGCOLUMNSID]) REFERENCES [RQTLOGCOLUMNS] ([ID])
ON DELETE CASCADE
GO

--    ***** Object:  Table [RQTLOGDOCUMENTS] *****
--    if not exists (select * from sysobjects where name='RQTLOGDOCUMENTS' and xtype='U')
--    CREATE TABLE [RQTLOGDOCUMENTS](
--       [RQTLOGID] [int] NOT NULL,
--       [RQDOCUMENTGUID] [varchar](40) NOT NULL,
--       [RQDOCUMENTMAPID] [varchar](40) NULL,
--       [VERSIONNUMBER] [varchar](50) NOT NULL,
--       [RQDOCUMENT] [text] NULL
--    ) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
--    
--    if not exists (select * from sysobjects where name='FK_RQTLOGDOCUMENTS_RQTLOG' and xtype='F')
--    ALTER TABLE [RQTLOGDOCUMENTS] WITH CHECK ADD CONSTRAINT [FK_RQTLOGDOCUMENTS_RQTLOG] FOREIGN KEY([RQTLOGID]) REFERENCES [RQTLOG] ([ID])
--    ON DELETE CASCADE
--    GO




-- ***** Object:  Table [RQTLOGMAP] *****
if not exists (select * from sysobjects where name='RQTLOGMAP' and xtype='U')
CREATE TABLE [RQTLOGMAP](
   [ID] [int] IDENTITY(1,1) NOT NULL,
   [OBJECTTYPE] [varchar](30) NOT NULL,
   [OBJECTGUID] [varchar](200) NOT NULL,
   [EXTERNALID] [varchar](40) NOT NULL,
 CONSTRAINT [PK_RQTLOGMAP] PRIMARY KEY CLUSTERED
(
   [ID] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY],
 CONSTRAINT [UK_RQTLOGMAP] UNIQUE NONCLUSTERED  ( OBJECTTYPE, OBJECTGUID )
) ON [PRIMARY]
GO


-- ***** Object:  Table [RQTLOGPROPERTY] *****
if not exists (select * from sysobjects where name='RQTLOGPROPERTY' and xtype='U')
CREATE TABLE [RQTLOGPROPERTY](
   [PROJECTGUID] [varchar](40) NOT NULL,
   [KEYNAME] [varchar](100) NOT NULL,
   [VALUE] [varchar](200) NOT NULL
 CONSTRAINT [PK_RQTLOGPROPERTY] PRIMARY KEY CLUSTERED
(
   [PROJECTGUID] ASC,
   [KEYNAME] ASC
)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]
) ON [PRIMARY]
GO








SET ANSI_PADDING OFF
GO

if not exists (select * from RQTLOGTRANSTYPE where id=1)
INSERT INTO RQTLOGTRANSTYPE VALUES (1, 'insert')

if not exists (select * from RQTLOGTRANSTYPE where id=2)
INSERT INTO RQTLOGTRANSTYPE VALUES (2, 'update')

if not exists (select * from RQTLOGTRANSTYPE where id=3)
INSERT INTO RQTLOGTRANSTYPE VALUES (3, 'delete')

if not exists (select * from RQTLOGOBJECTTYPE where id=1)
INSERT INTO RQTLOGOBJECTTYPE VALUES (1, 'project')

if not exists (select * from RQTLOGOBJECTTYPE where id=2)
INSERT INTO RQTLOGOBJECTTYPE VALUES (2, 'requirementtype')

if not exists (select * from RQTLOGOBJECTTYPE where id=3)
INSERT INTO RQTLOGOBJECTTYPE VALUES (3, 'attribute')

if not exists (select * from RQTLOGOBJECTTYPE where id=4)
INSERT INTO RQTLOGOBJECTTYPE VALUES (4, 'package')

if not exists (select * from RQTLOGOBJECTTYPE where id=5)
INSERT INTO RQTLOGOBJECTTYPE VALUES (5, 'document')

if not exists (select * from RQTLOGOBJECTTYPE where id=6)
INSERT INTO RQTLOGOBJECTTYPE VALUES (6, 'requirement')
GO



-- ***** Object:  StoredProcedure [RQINSERT_RQTLOG] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINSERT_RQTLOG]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINSERT_RQTLOG]
GO

-- ***** Object:  StoredProcedure [RQINSERT_RQTLOG] *****
CREATE PROCEDURE [RQINSERT_RQTLOG]
(
   @PROJECTGUID varchar(40)
   ,@PROJECTMAPID varchar(40)
   ,@USERID varchar(20)
   ,@TDATE datetime
   ,@ISDOCUMENT bit
   ,@RQTTRANSTYPEID int
   ,@RQTOBJECTTYPEID int
   ,@RQTOBJECTGUID varchar(40)
   ,@RQTEXTERNALID varchar(40)
   ,@LOGSID int = NULL OUTPUT
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   -- insert column values into RQTLOG table
   INSERT INTO RQTLOG (PROJECTGUID,PROJECTMAPID,USERID,TDATE,ISDOCUMENT,RQTTRANSTYPEID,RQTOBJECTTYPEID,RQTOBJECTGUID,RQTEXTERNALID)
   VALUES (@PROJECTGUID,@PROJECTMAPID,@USERID,@TDATE,@ISDOCUMENT,@RQTTRANSTYPEID,@RQTOBJECTTYPEID,@RQTOBJECTGUID,@RQTEXTERNALID)
   SELECT @LOGSID=@@IDENTITY
END
GO


-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGCOLUMNS] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINSERT_RQTLOGCOLUMNS]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINSERT_RQTLOGCOLUMNS]
GO

-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGCOLUMNS] *****
CREATE PROCEDURE [RQINSERT_RQTLOGCOLUMNS]
(
   @RQTLOGID int
   ,@TABLENAME varchar(150)
   ,@TID varchar(40)
   ,@COLUMNNAME varchar(300)
   ,@COLUMNVALUE varchar(MAX)
   ,@ISOVERFLOW bit
   ,@LOGSCOLUMNID int = NULL OUTPUT
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   VALUES (@RQTLOGID,@TABLENAME,@TID,@COLUMNNAME,@COLUMNVALUE,@ISOVERFLOW)
   SELECT @LOGSCOLUMNID=@@IDENTITY
END
GO


-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGOVERFLOW] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINSERT_RQTLOGOVERFLOW]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINSERT_RQTLOGOVERFLOW]
GO

-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGOVERFLOW] *****
CREATE PROCEDURE [RQINSERT_RQTLOGOVERFLOW]
(
   @RQTLOGCOLUMNSID int
   ,@OVERFLOWTEXT text
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   -- insert column values into RQTLOG table
   INSERT INTO RQTLOGOVERFLOW (RQTLOGCOLUMNSID,OVERFLOWTEXT)
   VALUES (@RQTLOGCOLUMNSID, @OVERFLOWTEXT)
END
GO


-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGDOCUMENTS] *****
--    IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINSERT_RQTLOGDOCUMENTS]') AND type in (N'P', N'PC'))
--    DROP PROCEDURE [RQINSERT_RQTLOGDOCUMENTS]
--    GO

-- ***** Object:  StoredProcedure [RQINSERT_RQTLOGDOCUMENTS] *****
--    CREATE PROCEDURE [RQINSERT_RQTLOGDOCUMENTS]
--    (
--       @RQTLOGID int
--       ,@RQDOCUMENTGUID varchar(40)
--       ,@RQDOCUMENTMAPID varchar(40)
--       ,@VERSIONNUMBER varchar(50)
--       ,@RQDOCUMENT text
--    )
--    AS
--    BEGIN
--       -- SET NOCOUNT ON added to prevent extra result sets from
--       -- interfering with SELECT statements.
--       SET NOCOUNT ON;
--    
--       -- insert column values into RQTLOG table
--       INSERT INTO RQTLOGDOCUMENTS (RQTLOGID,RQDOCUMENTGUID,RQDOCUMENTMAPID,VERSIONNUMBER,RQDOCUMENT)
--       VALUES (@RQTLOGID, @RQDOCUMENTGUID, @RQDOCUMENTMAPID, @VERSIONNUMBER, @RQDOCUMENT)
--    END
--    GO


-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_FIELDVALUES] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINS_TLOGCOLUMNS_FIELDVALUES]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINS_TLOGCOLUMNS_FIELDVALUES]
GO

-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_FIELDVALUES] *****
CREATE PROCEDURE [RQINS_TLOGCOLUMNS_FIELDVALUES]
(
   @RQTLOGID int
   ,@REQUIREMENTID int
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   -- insert column values into RQTLOGCOLUMNS table
   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r2.RQGUID,'REQUIREMENTID',r1.REQUIREMENTID,0
   FROM RQUSERDEFINEDFIELDVALUES r1
   INNER JOIN RQUSERDEFINEDFIELDS r2 ON r1.FIELDID=r2.ID
   WHERE r1.REQUIREMENTID = @REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r3.RQGUID,'REQUIREMENTGUID',r2.RQGUID,0
   FROM RQUSERDEFINEDFIELDVALUES r1
   INNER JOIN RQREQUIREMENTS r2 ON r1.REQUIREMENTID=r2.ID
   INNER JOIN RQUSERDEFINEDFIELDS r3 ON r1.FIELDID=r3.ID
   WHERE r1.REQUIREMENTID = @REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r4.RQGUID,'REQUIREMENTMAPID',EXTERNALID,0
   FROM RQUSERDEFINEDFIELDVALUES r1
   INNER JOIN RQREQUIREMENTS r2 ON r1.REQUIREMENTID=r2.ID
   INNER JOIN RQTLOGMAP r3 ON r2.RQGUID=r3.OBJECTGUID
   INNER JOIN RQUSERDEFINEDFIELDS r4 ON r1.FIELDID=r4.ID
   WHERE r1.REQUIREMENTID = @REQUIREMENTID AND r3.OBJECTTYPE='RQREQUIREMENTS'

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r3.RQGUID,'FIELDVALUE',r4.FIELDVALUE,ISNULL(r4.OVERFLOWIND,0)
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   INNER JOIN RQUSERDEFINEDFIELDS r3 ON r2.USERDEFINEDFIELDID=r3.ID
   LEFT OUTER JOIN RQUSERDEFINEDFIELDVALUES r4 ON r3.ID=r4.FIELDID AND r1.ID=r4.REQUIREMENTID
   WHERE r1.ID=@REQUIREMENTID AND r3.DATATYPE<>0

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r2.RQGUID,'OVERFLOWIND',r1.OVERFLOWIND,0
   FROM RQUSERDEFINEDFIELDVALUES r1
   INNER JOIN RQUSERDEFINEDFIELDS r2 ON r1.FIELDID=r2.ID
   WHERE r1.REQUIREMENTID = @REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r2.RQGUID,'NUMERICVALUE',r1.NUMERICVALUE,0
   FROM RQUSERDEFINEDFIELDVALUES r1
   INNER JOIN RQUSERDEFINEDFIELDS r2 ON r1.FIELDID=r2.ID
   WHERE r1.REQUIREMENTID = @REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r3.RQGUID,'FIELDGUID',r3.RQGUID,0
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   INNER JOIN RQUSERDEFINEDFIELDS r3 ON r2.USERDEFINEDFIELDID=r3.ID
   WHERE r1.ID=@REQUIREMENTID AND r3.DATATYPE<>0

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDFIELDVALUES',r3.RQGUID,'FIELDMAPID',r4.EXTERNALID,0
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   INNER JOIN RQUSERDEFINEDFIELDS r3 ON r2.USERDEFINEDFIELDID=r3.ID
   INNER JOIN RQTLOGMAP r4 ON r3.RQGUID=r4.OBJECTGUID
   WHERE r1.ID = @REQUIREMENTID 
   AND r3.DATATYPE<>0 
   AND r4.OBJECTTYPE = 'RQUSERDEFINEDFIELDS'

   --insert columns values into RQTLOGOVERFOW table
   INSERT INTO RQTLOGOVERFLOW (RQTLOGCOLUMNSID,OVERFLOWTEXT)
   SELECT r1.ID, r2.OVERFLOWFIELDVALUE
   FROM RQTLOGCOLUMNS r1
   INNER JOIN RQOVERFLOWVALUES r2 ON r1.TID=r2.OVERFLOWFIELDID
   WHERE r1.RQTLOGID=@RQTLOGID
   AND r1.TABLENAME='RQUSERDEFINEDFIELDVALUES'
   AND r1.COLUMNNAME='FIELDVALUE'
   AND r1.ISOVERFLOW=1
   AND r2.OVERFLOWREQUIREMENTID=@REQUIREMENTID
END
GO


-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_LISTVALUES] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINS_TLOGCOLUMNS_LISTVALUES]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINS_TLOGCOLUMNS_LISTVALUES]
GO

-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_LISTVALUES] *****
CREATE PROCEDURE [RQINS_TLOGCOLUMNS_LISTVALUES]
(
   @RQTLOGID int
   ,@REQUIREMENTID int
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   -- insert column values into RQTLOGCOLUMNS table
   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r4.RQGUID,'REQUIREMENTGUID',r2.RQGUID,0
   FROM RQUSERDEFINEDLISTVALUES r1
   INNER JOIN RQREQUIREMENTS r2 ON r1.REQUIREMENTID=r2.ID
   INNER JOIN RQUSERDEFINEDLISTITEMS r3 ON r1.LISTITEMID=r3.ITEMID
   INNER JOIN RQUSERDEFINEDFIELDS r4 ON r1.FIELDID=r4.ID
   WHERE r1.REQUIREMENTID=@REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r5.RQGUID,'FIELDGUID',r5.RQGUID,0
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   LEFT OUTER JOIN RQUSERDEFINEDLISTVALUES r3 ON r2.USERDEFINEDFIELDID=r3.FIELDID AND r1.ID=r3.REQUIREMENTID
   FULL OUTER JOIN RQUSERDEFINEDLISTITEMS r4 ON r3.LISTITEMID=r4.ITEMID
   INNER JOIN RQUSERDEFINEDFIELDS r5 ON r2.USERDEFINEDFIELDID=r5.ID
   WHERE r1.ID=@REQUIREMENTID AND r5.DATATYPE=0

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r5.RQGUID,'ITEMGUID',r4.RQGUID,0
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   LEFT OUTER JOIN RQUSERDEFINEDLISTVALUES r3 ON r2.USERDEFINEDFIELDID=r3.FIELDID AND r1.ID=r3.REQUIREMENTID
   FULL OUTER JOIN RQUSERDEFINEDLISTITEMS r4 ON r3.LISTITEMID=r4.ITEMID
   INNER JOIN RQUSERDEFINEDFIELDS r5 ON r2.USERDEFINEDFIELDID=r5.ID
   WHERE r1.ID=@REQUIREMENTID AND r5.DATATYPE=0

   -- insert external MAP ID values
   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r5.RQGUID,'REQUIREMENTMAPID',r3.EXTERNALID,0
   FROM RQUSERDEFINEDLISTVALUES r1
   INNER JOIN RQREQUIREMENTS r2 ON r1.REQUIREMENTID=r2.ID
   INNER JOIN RQTLOGMAP r3 ON r2.RQGUID=r3.OBJECTGUID
   INNER JOIN RQUSERDEFINEDLISTITEMS r4 ON r1.LISTITEMID=r4.ITEMID
   INNER JOIN RQUSERDEFINEDFIELDS r5 ON r1.FIELDID=r5.ID
   WHERE r1.REQUIREMENTID=@REQUIREMENTID

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r3.RQGUID,'FIELDMAPID',r4.EXTERNALID,0
   FROM RQREQUIREMENTS r1
   INNER JOIN RQREQUIREMENTTYPEFIELDS r2 ON r1.REQUIREMENTTYPEID=r2.REQUIREMENTTYPEID
   INNER JOIN RQUSERDEFINEDFIELDS r3 ON r2.USERDEFINEDFIELDID=r3.ID
   INNER JOIN RQTLOGMAP r4 ON r3.RQGUID=r4.OBJECTGUID
   WHERE r1.ID=@REQUIREMENTID AND r3.DATATYPE=0

   INSERT INTO RQTLOGCOLUMNS (RQTLOGID,TABLENAME,TID,COLUMNNAME,COLUMNVALUE,ISOVERFLOW)
   SELECT @RQTLOGID,'RQUSERDEFINEDLISTVALUES',r4.RQGUID,'ITEMMAPID',r3.EXTERNALID,0
   FROM RQUSERDEFINEDLISTVALUES r1
   INNER JOIN RQUSERDEFINEDLISTITEMS r2 ON r1.LISTITEMID=r2.ITEMID
   INNER JOIN RQTLOGMAP r3 ON r2.RQGUID=r3.OBJECTGUID
   INNER JOIN RQUSERDEFINEDFIELDS r4 ON r1.FIELDID=r4.ID
   WHERE r1.REQUIREMENTID=@REQUIREMENTID
END
GO


-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_REQ] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINS_TLOGCOLUMNS_REQ]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINS_TLOGCOLUMNS_REQ]
GO

-- ***** Object:  StoredProcedure [RQINS_TLOGCOLUMNS_REQ] *****
CREATE PROCEDURE [RQINS_TLOGCOLUMNS_REQ]
(
   @TLOGID int
   ,@REQUIREMENTID int
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   --Declarations of RQRequirement columns values
   DECLARE @RQREQUIREMENTID int
   DECLARE @REQUIREMENTTYPEID int
   DECLARE @TAG int
   DECLARE @LASTCHILDTAG int
   DECLARE @BOOKMARKNAME varchar(64)
   DECLARE @BOOKMARKDOCUMENTID int
   DECLARE @DOCUMENTPOSITION smallint
   DECLARE @LONGTAGNUMBER varchar(255)
   DECLARE @REQUIREMENTPREFIX varchar(64)
   DECLARE @REQUIREMENTTEXT varchar(4000)
   DECLARE @REQOVERFLOWIND bit
   DECLARE @DELETED bit
   DECLARE @RQGUID varchar(40)
   DECLARE @REQFLAGS int
   DECLARE @LASTDOCTEXT int
   DECLARE @REQUIREMENTNAME varchar(255)
   DECLARE @SUSPECTDATETIME datetime

   --Local variable declarations
   DECLARE @LOGSCOLUMNTID int
   DECLARE @LOGSOVERFLOWTEXT varchar(max)
   DECLARE @RQDOCGUID varchar(40)
   DECLARE @RQDOCMAPID varchar(40)
   DECLARE @RQREQTYPEGUID varchar(40)
   DECLARE @RQREQTYPEMAPID varchar(40)
   DECLARE @EXTERNALID varchar(40)

   --Populate values from the RQREQUIREMENTS table
   SELECT @RQREQUIREMENTID  = ID
      ,@REQUIREMENTTYPEID  = ISNULL(REQUIREMENTTYPEID,'')
      ,@TAG  = ISNULL(TAG,-1)
      ,@LASTCHILDTAG  = ISNULL(LASTCHILDTAG,-1)
      ,@BOOKMARKNAME  = ISNULL(BOOKMARKNAME,'')
      ,@BOOKMARKDOCUMENTID  = ISNULL(BOOKMARKDOCUMENTID,-1)
      ,@DOCUMENTPOSITION  = ISNULL(DOCUMENTPOSITION,-1)
      ,@LONGTAGNUMBER  = ISNULL(LONGTAGNUMBER,'')
      ,@REQUIREMENTPREFIX  = ISNULL(REQUIREMENTPREFIX,'')
      ,@REQUIREMENTTEXT  = ISNULL(REQUIREMENTTEXT,'')
      ,@REQOVERFLOWIND  = ISNULL(OVERFLOWIND,0)
      ,@DELETED  = ISNULL(DELETED,-1)
      ,@RQGUID  = ISNULL(RQGUID,'')
      ,@REQFLAGS = ISNULL(FLAGS,-1)
      ,@LASTDOCTEXT  = ISNULL(LASTDOCTEXT,-1)
      ,@REQUIREMENTNAME  = ISNULL(REQUIREMENTNAME,'')
      ,@SUSPECTDATETIME  = ISNULL(SUSPECTDATETIME,'')
   FROM RQREQUIREMENTS
   WHERE ID = @REQUIREMENTID

   If @RQREQUIREMENTID IS NOT NULL
   BEGIN
      -- get guids from id
      SELECT @RQREQTYPEGUID=RQGUID FROM RQREQUIREMENTTYPES WHERE ID=@REQUIREMENTTYPEID
      SELECT @RQDOCGUID=RQGUID FROM RQDOCUMENTS WHERE ID=@BOOKMARKDOCUMENTID

      -- get external map ids from RQTLOGMAP table
      SELECT @RQREQTYPEMAPID=EXTERNALID FROM RQTLOGMAP WHERE OBJECTGUID=@RQREQTYPEGUID AND OBJECTTYPE='RQREQUIREMENTTYPES'
      SELECT @EXTERNALID=EXTERNALID     FROM RQTLOGMAP WHERE OBJECTGUID=@RQGUID        AND OBJECTTYPE='RQREQUIREMENTS'
      SELECT @RQDOCMAPID=EXTERNALID     FROM RQTLOGMAP WHERE OBJECTGUID=@RQDOCGUID     AND OBJECTTYPE='RQDOCUMENTS'

      --insert column values into RQTLOGCOLUMNS table
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='REQUIREMENTID',         @COLUMNVALUE=@RQREQUIREMENTID,    @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='REQUIREMENTTYPEGUID',   @COLUMNVALUE=@RQREQTYPEGUID,      @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='REQUIREMENTTYPEMAPID',  @COLUMNVALUE=@RQREQTYPEMAPID,     @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='TAG',                   @COLUMNVALUE=@TAG,                @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='LASTCHILDTAG',          @COLUMNVALUE=@LASTCHILDTAG,       @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='BOOKMARKNAME',          @COLUMNVALUE=@BOOKMARKNAME,       @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='BOOKMARKDOCUMENTID',    @COLUMNVALUE=@BOOKMARKDOCUMENTID, @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='BOOKMARKDOCUMENTGUID',  @COLUMNVALUE=@RQDOCGUID,          @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='BOOKMARKDOCUMENTMAPID', @COLUMNVALUE=@RQDOCMAPID,         @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='DOCUMENTPOSITION',      @COLUMNVALUE=@DOCUMENTPOSITION,   @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='LONGTAGNUMBER',         @COLUMNVALUE=@LONGTAGNUMBER,      @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='REQUIREMENTPREFIX',     @COLUMNVALUE=@REQUIREMENTPREFIX,  @ISOVERFLOW=0

      --Check whether an overflow exists. If exists populate the RQTLOGOVERFLOW table for the REQUIREMENTTEXT column entry
      If @REQOVERFLOWIND=1
      BEGIN
         EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID,@TABLENAME='RQREQUIREMENTS',@TID=@RQGUID,@COLUMNNAME='REQUIREMENTTEXT',@COLUMNVALUE=@REQUIREMENTTEXT,@ISOVERFLOW=1,@LOGSCOLUMNID=@LOGSCOLUMNTID OUTPUT
         SET @LOGSOVERFLOWTEXT=(SELECT OVERFLOWTEXT FROM RQOVERFLOWTEXT WHERE OVERFLOWID=@RQREQUIREMENTID)
         EXECUTE RQINSERT_RQTLOGOVERFLOW @RQTLOGCOLUMNSID=@LOGSCOLUMNTID,@OVERFLOWTEXT=@LOGSOVERFLOWTEXT
      END
      ELSE
      BEGIN
         EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID,@TABLENAME='RQREQUIREMENTS',@TID=@RQGUID,@COLUMNNAME='REQUIREMENTTEXT',@COLUMNVALUE=@REQUIREMENTTEXT,@ISOVERFLOW=0
      END

      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='OVERFLOWIND',     @COLUMNVALUE=@REQOVERFLOWIND,  @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='DELETED',         @COLUMNVALUE=@DELETED,         @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='RQGUID',          @COLUMNVALUE=@RQGUID,          @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='MAPID',           @COLUMNVALUE=@EXTERNALID,      @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='FLAGS',           @COLUMNVALUE=@REQFLAGS,        @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='LASTDOCTEXT',     @COLUMNVALUE=@LASTDOCTEXT,     @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='REQUIREMENTNAME', @COLUMNVALUE=@REQUIREMENTNAME, @ISOVERFLOW=0
      EXECUTE RQINSERT_RQTLOGCOLUMNS @RQTLOGID=@TLOGID, @TABLENAME='RQREQUIREMENTS', @TID=@RQGUID, @COLUMNNAME='SUSPECTDATETIME', @COLUMNVALUE=@SUSPECTDATETIME, @ISOVERFLOW=0
   END
END
GO



-- ***** Object:  StoredProcedure [RQDELETE_RQTLOGMAP_ENTRY] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQDELETE_RQTLOGMAP_ENTRY]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQDELETE_RQTLOGMAP_ENTRY]
GO

-- ***** Object:  StoredProcedure [RQDELETE_RQTLOGMAP_ENTRY] *****
CREATE PROCEDURE [RQDELETE_RQTLOGMAP_ENTRY]
(
   @OBJECTTYPE varchar(40),
   @OBJECTGUID varchar(40)
)
AS
BEGIN

   DECLARE @RQREQUIREMENTID int

   -- Delete the RQTLOGMAP entry for this requirement.
   DELETE FROM RQTLOGMAP WHERE OBJECTTYPE=@OBJECTTYPE and OBJECTGUID=@OBJECTGUID

   -- Delete on RQRESOURCES not necessary since RQRES_REQID_FK constraint implements CASCADE when deleting requirements
   --IF UPPER(RTRIM(@OBJECTTYPE))='RQREQUIREMENTS'
   --BEGIN
   --   -- Delete the RQRESOURCES entry for this requirement.
   --   SELECT @RQREQUIREMENTID = ID FROM RQREQUIREMENTS WHERE RQGUID = @OBJECTGUID
   --   DELETE FROM RQRESOURCES WHERE FLAGS=2 AND REQUIREMENTID=@RQREQUIREMENTID
   --END

END
GO



-- ***** Object:  StoredProcedure [RQINSERT_LOG_REQUIREMENT] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQINSERT_LOG_REQUIREMENT]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQINSERT_LOG_REQUIREMENT]
GO

-- ***** Object:  StoredProcedure [RQINSERT_LOG_REQUIREMENT] *****
CREATE PROCEDURE [RQINSERT_LOG_REQUIREMENT]
(
   @PROJECTGUID varchar(40)
   ,@REQUIREMENTGUID varchar(40)
   ,@TRANSTYPE int
)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	--Declarations of RQRequirement columns values
	DECLARE @RQREQUIREMENTID int
	DECLARE @VERSIONUSERID int
	DECLARE @VERSIONDATETIME datetime
	DECLARE @BOOKMARKDOCUMENTID int

	--Local variable declarations
	DECLARE @LOGSTID int
	DECLARE @ISDOC bit
	DECLARE @DOCVERNUMBER varchar(50)
	DECLARE @RQPROJECTMAPID varchar(40)
	DECLARE @RQUSERID varchar(20)
	DECLARE @RQDOCGUID varchar(40)
	DECLARE @RQDOCMAPID varchar(40)
	DECLARE @EXTERNALID varchar(40)

	--Populate values from the RQREQUIREMENTS table
    	SELECT @RQREQUIREMENTID  = ID
			,@BOOKMARKDOCUMENTID  = ISNULL(BOOKMARKDOCUMENTID,-1)
			,@VERSIONUSERID  = ISNULL(VERSIONUSERID,-1)
			,@VERSIONDATETIME  = ISNULL(VERSIONDATETIME,getdate())
	FROM RQREQUIREMENTS WHERE RQGUID = @REQUIREMENTGUID

	If @RQREQUIREMENTID IS NOT NULL
	BEGIN
		--Set default values
		SET @ISDOC = 0
		If @BOOKMARKDOCUMENTID>0
		BEGIN
			SET @ISDOC = 1
		END

		-- get user guid and login name from id
		SELECT @RQUSERID=ISNULL(LOGINNAME,'UNKNOWN') FROM RQUSERS WHERE ID=@VERSIONUSERID

		-- get external map ids from RQTLOGMAP table
		SELECT @RQPROJECTMAPID=EXTERNALID FROM RQTLOGMAP WHERE OBJECTGUID=@PROJECTGUID     AND OBJECTTYPE='RQPROJECTS'
		SELECT @EXTERNALID=EXTERNALID     FROM RQTLOGMAP WHERE OBJECTGUID=@REQUIREMENTGUID AND OBJECTTYPE='RQREQUIREMENTS'

		-- insert column values into RQTLOG table
		EXECUTE RQINSERT_RQTLOG @PROJECTGUID=@PROJECTGUID,@PROJECTMAPID=@RQPROJECTMAPID,@USERID=@RQUSERID,@TDATE=@VERSIONDATETIME,@ISDOCUMENT=@ISDOC,
			   @RQTTRANSTYPEID=@TRANSTYPE,@RQTOBJECTTYPEID=6,@RQTOBJECTGUID=@REQUIREMENTGUID,@RQTEXTERNALID=@EXTERNALID,@LOGSID=@LOGSTID OUTPUT

		If @TRANSTYPE <> 3 -- If other than DELETE
		BEGIN
			--insert requirement source document to RQTLOGDOCUMENTS
--    			If @ISDOC=1
--    			BEGIN
--    				SELECT @DOCVERNUMBER=VERSIONNUMBER, @RQDOCGUID=RQGUID FROM RQDOCUMENTS WHERE ID=@BOOKMARKDOCUMENTID
--    				SELECT @RQDOCMAPID=EXTERNALID FROM RQTLOGMAP WHERE OBJECTGUID=@RQDOCGUID AND OBJECTTYPE='RQDOCUMENTS'
--    				EXECUTE RQINSERT_RQTLOGDOCUMENTS @RQTLOGID=@LOGSTID,@RQDOCUMENTGUID=@RQDOCGUID,@RQDOCUMENTMAPID=@RQDOCMAPID,@VERSIONNUMBER=@DOCVERNUMBER,@RQDOCUMENT='DOCUMENT'
--    			END

			--insert for RQREQUIREMENTS
			--insert column values into RQTLOGCOLUMNS table
			EXECUTE RQINS_TLOGCOLUMNS_REQ @TLOGID=@LOGSTID,@REQUIREMENTID=@RQREQUIREMENTID

			--insert for RQUSERDEFINEDFIELDVALUES
			--insert column values into RQTLOGCOLUMNS table
			EXECUTE RQINS_TLOGCOLUMNS_FIELDVALUES @RQTLOGID=@LOGSTID,@REQUIREMENTID=@RQREQUIREMENTID

			--insert for RQUSERDEFINEDLISTITEMS
			--insert column values into RQTLOGCOLUMNS table
			EXECUTE RQINS_TLOGCOLUMNS_LISTVALUES @RQTLOGID=@LOGSTID,@REQUIREMENTID=@RQREQUIREMENTID
		END

	END
END
GO


-- ***** Object:  StoredProcedure [RQDELETE_LOG_REQUIREMENT] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQDELETE_LOG_REQUIREMENT]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQDELETE_LOG_REQUIREMENT]
GO

-- ***** Object:  StoredProcedure [RQDELETE_LOG_REQUIREMENT] *****
CREATE PROCEDURE [RQDELETE_LOG_REQUIREMENT]
(
   @PROJECTGUID      varchar(40),
   @REQUIREMENTGUID  varchar(40),
   @VERSIONUSERID    int
)
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

   --Declarations of RQRequirement columns values
   DECLARE @RQREQUIREMENTID int

   --Local variable declarations
   DECLARE @LOGSTID           int
   DECLARE @RQPROJECTFLAGS    int
   DECLARE @RQPROJECTMAPID    varchar(40)
   DECLARE @RQUSERID          varchar(20)
   DECLARE @EXTERNALID        varchar(40)
   DECLARE @VERSIONDATETIME   datetime
   
   SET @VERSIONDATETIME=GETDATE()

   SELECT @RQPROJECTFLAGS=FLAGS from RQPROJECTS where RQGUID=@PROJECTGUID
   
   IF ((@RQPROJECTFLAGS & 64) <> 0) 
   BEGIN
      IF (SELECT COUNT(*) FROM RQTLOGMAP WHERE OBJECTGUID=@REQUIREMENTGUID AND OBJECTTYPE='RQREQUIREMENTS' AND EXTERNALID IS NOT NULL) > 0
      BEGIN
      
         -- get user guid and login name from id
         SELECT @RQUSERID=ISNULL(LOGINNAME,'UNKNOWN') FROM RQUSERS WHERE ID=@VERSIONUSERID
      
         -- get external map ids from RQTLOGMAP table
         SELECT @RQPROJECTMAPID=EXTERNALID FROM RQTLOGMAP WHERE OBJECTGUID=@PROJECTGUID     AND OBJECTTYPE='RQPROJECTS'
         SELECT @EXTERNALID=EXTERNALID     FROM RQTLOGMAP WHERE OBJECTGUID=@REQUIREMENTGUID AND OBJECTTYPE='RQREQUIREMENTS'
      
         -- insert column values into RQTLOG table
         EXECUTE RQINSERT_RQTLOG @PROJECTGUID=@PROJECTGUID,@PROJECTMAPID=@RQPROJECTMAPID,@USERID=@RQUSERID,@TDATE=@VERSIONDATETIME,@ISDOCUMENT=0,
               @RQTTRANSTYPEID=3,@RQTOBJECTTYPEID=6,@RQTOBJECTGUID=@REQUIREMENTGUID,@RQTEXTERNALID=@EXTERNALID,@LOGSID=@LOGSTID OUTPUT
      
         -- Delete the requirement sync information for this requirement
         EXECUTE RQDELETE_RQTLOGMAP_ENTRY @OBJECTTYPE='RQREQUIREMENTS', @OBJECTGUID=@REQUIREMENTGUID
      
      END
   END

END
GO




-- ***** Object:  StoredProcedure [MIGRATE_TLOGMAP] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[MIGRATE_TLOGMAP]') AND type in (N'P', N'PC'))
DROP PROCEDURE [MIGRATE_TLOGMAP]
GO




-- ***** Object:  Trigger [RQREQUIREMENTHISTORY_ITRIG_LOG] *****
IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RQREQUIREMENTHISTORY_ITRIG_LOG]'))
DROP TRIGGER [RQREQUIREMENTHISTORY_ITRIG_LOG]
GO

-- ***** Object:  Trigger [RQREQUIREMENTHISTORY_ITRIG_LOG] *****
CREATE TRIGGER [RQREQUIREMENTHISTORY_ITRIG_LOG] ON [RQREQUIREMENTHISTORY] FOR INSERT
AS
BEGIN
   -- SET NOCOUNT ON added to prevent extra result sets from
   -- interfering with SELECT statements.
   SET NOCOUNT ON;

    -- Declarations of the current columns values
   DECLARE @RQREQUIREMENTHISTORYID  int
   DECLARE @VERSIONUSERID           int
   DECLARE @VERSIONNUMBER           varchar (50)

   --Declarations of RQRequirement columns values
   DECLARE @RQREQGUID               varchar(40)

   --Local variable declarations
   DECLARE @RQPROJECTGUID           varchar(40)
   DECLARE @VERSIONUSERNAME         varchar(40)
   DECLARE @RQPROJECTFLAGS          int
   DECLARE @RRMSYNCUSERNAME         varchar(40)

   -- Get values from the base table
   SELECT @RQREQUIREMENTHISTORYID=ID, @VERSIONUSERID=VERSIONUSERID, @VERSIONNUMBER=VERSIONNUMBER FROM inserted

   -- Do not start work unless this is an update to an existing requirement.
   IF ( @VERSIONNUMBER <> '1.0000')
   BEGIN
      -- Get login name of the user who updated the RequisitePro requirement.
      SELECT @VERSIONUSERNAME=LOGINNAME FROM RqUsers WHERE id=@VERSIONUSERID

      -- get project guid and flags from RQPROJECTS, userid of the updater, userid from RqUsers
      -- All from a single query to take advantage of the schema relationship and save calls and time.
      SELECT
         @RQPROJECTFLAGS=RQPROJECTS.FLAGS,
         @RQPROJECTGUID=RQPROJECTS.RQGUID,
         @RQREQGUID=RQREQUIREMENTS.RQGUID,
         @RRMSYNCUSERNAME=RQTLOGPROPERTY.VALUE
      FROM
         RQPROJECTS INNER JOIN
         RQPROJECTREQUIREMENTS ON RQPROJECTS.ID = RQPROJECTREQUIREMENTS.PROJECTID INNER JOIN
         RQTLOGPROPERTY ON RQPROJECTS.RQGUID = RQTLOGPROPERTY.PROJECTGUID INNER JOIN
         RQREQUIREMENTS ON RQPROJECTREQUIREMENTS.REQUIREMENTID = RQREQUIREMENTS.ID
      WHERE
         (RQTLOGPROPERTY.KEYNAME = 'RRMSyncUser') AND
         (RQPROJECTREQUIREMENTS.REQUIREMENTID = @RQREQUIREMENTHISTORYID)

      IF ( ((@RQPROJECTFLAGS & 64) <> 0) AND (@RRMSYNCUSERNAME <> @VERSIONUSERNAME) )
      BEGIN
         IF (SELECT COUNT(*) FROM RQTLOGMAP WHERE OBJECTGUID=@RQREQGUID AND OBJECTTYPE='RQREQUIREMENTS' AND EXTERNALID IS NOT NULL) > 0
         BEGIN
            -- insert entries into TLog tables for Requirement
            EXECUTE RQINSERT_LOG_REQUIREMENT @PROJECTGUID=@RQPROJECTGUID,@REQUIREMENTGUID=@RQREQGUID,@TRANSTYPE=2
         END
      END
   END
END
GO



IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[RQTLOGMAP_DTRIG]'))
DROP TRIGGER [RQTLOGMAP_DTRIG]
GO

--CREATE TRIGGER RQTLOGMAP_DTRIG ON RQTLOGMAP FOR DELETE AS
--IF EXISTS (SELECT * FROM DELETED WHERE OBJECTTYPE = 'RQPROJECTS')
--BEGIN
--
--   DECLARE @PRJGUID varchar(40)
--   SELECT @PRJGUID = (SELECT OBJECTGUID FROM DELETED)
   --
--   -- Remove integration data for this project
--   DELETE FROM RQTLOGPROPERTY WHERE PROJECTGUID=@PRJGUID
   --
--   -- Remove entries in RqTLogMap table related to this project
--   DELETE FROM RQTLOGMAP WHERE ID IN (
--      -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTS
--      SELECT 
--         M.ID
--      FROM 
--         RQTLOGMAP M, 
--         RQPROJECTS P, 
--         RQPROJECTREQUIREMENTS PR, 
--         RQREQUIREMENTS R
--      WHERE 
--         P.ID=PR.PROJECTID AND
--         PR.REQUIREMENTID= R.ID AND
--         R.RQGUID=M.OBJECTGUID AND
--         P.RQGUID=@PRJGUID
         --
--      UNION ALL
         --
--      -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTTYPES
--      SELECT 
--         M.ID
--      FROM 
--         RQTLOGMAP M, 
--         RQPROJECTS P, 
--         RQPROJECTREQUIREMENTTYPES PT, 
--         RQREQUIREMENTTYPES T
--      WHERE 
--         P.ID=PT.PROJECTID AND
--         PT.REQUIREMENTTYPEID= T.ID AND
--         T.RQGUID=M.OBJECTGUID AND
--         P.RQGUID=@PRJGUID
      --
--      UNION ALL
      --
--      -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDFIELDS
--      SELECT 
--         M.ID
--      FROM 
--         RQTLOGMAP M, 
--         RQPROJECTS P, 
--         RQPROJECTREQUIREMENTTYPES PT, 
--         RQREQUIREMENTTYPES T, 
--         RQREQUIREMENTTYPEFIELDS TF, 
--         RQUSERDEFINEDFIELDS F
--      WHERE 
--         P.ID=PT.PROJECTID AND
--         PT.REQUIREMENTTYPEID= T.ID AND
--         T.ID=TF.REQUIREMENTTYPEID AND
--         TF.USERDEFINEDFIELDID=F.ID AND
--         F.RQGUID=M.OBJECTGUID AND
--         P.RQGUID=@PRJGUID
   --
--      UNION ALL
      --
--      -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDLISTITEMS
--      SELECT 
--         M.ID
--      FROM 
--         RQTLOGMAP M, 
--         RQPROJECTS P, 
--         RQPROJECTREQUIREMENTTYPES PT, 
--         RQREQUIREMENTTYPES T, 
--         RQREQUIREMENTTYPEFIELDS TF, 
--         RQUSERDEFINEDFIELDS F, 
--         RQUSERDEFINEDLISTITEMS I
--      WHERE 
--         P.ID=PT.PROJECTID AND
--         PT.REQUIREMENTTYPEID= T.ID AND
--         T.ID=TF.REQUIREMENTTYPEID AND
--         TF.USERDEFINEDFIELDID=F.ID AND
--         F.ID=I.FIELDID AND
--         I.RQGUID=M.OBJECTGUID AND
--         P.RQGUID=@PRJGUID
         --
--      )
   --
--   -- Remove RRC link for this project's requirements
--   DELETE from rqresources where id in ( SELECT RS.ID FROM RqRequirements R, rqprojectrequirements PR, rqprojects P, rqresources RS  where R.id = PR.requirementid and P.id = PR.projectid AND R.ID=RS.REQUIREMENTID AND RS.FLAGS=2 AND P.RQGUID=@PRJGUID )
   --
--   -- turn off sync flag for this project
--   UPDATE RQPROJECTS SET FLAGS=(FLAGS&(~(64))) WHERE RQGUID=@PRJGUID
--
--END
--GO
--









-- ***** Object:  StoredProcedure [RQDEL_RQTLOGMAP] *****
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[RQDEL_RQTLOGMAP]') AND type in (N'P', N'PC'))
DROP PROCEDURE [RQDEL_RQTLOGMAP]
GO

-- ***** Object:  StoredProcedure [RQDEL_RQTLOGMAP] *****
-- DROP PROCEDURE RQDEL_RQTLOGMAP
CREATE PROCEDURE [RQDEL_RQTLOGMAP]
(
   @L_PRJGUID    varchar(40),
   @L_OBJECTTYPE varchar(30),
   @L_UNIQUEIDL1 varchar(40),
   @L_UNIQUEIDL2 varchar(40),
   @L_UNIQUEIDL3 varchar(40),
   @L_IDTYPE        INT
)
AS
BEGIN

   DECLARE @L_TLOGMAPID int
   DECLARE @L_REQID int
   DECLARE @L_REQTYPEID int
   DECLARE @L_OBJECTGUID varchar(40)

   SET @L_TLOGMAPID=0
   SET @L_REQID=0
   SET @L_REQTYPEID=0
   SET @L_OBJECTGUID=''


   IF (@L_IDTYPE=0) -- the unique id is an external id
   BEGIN

      IF (@L_OBJECTTYPE='RQREQUIREMENTS') 
      BEGIN
         SELECT TOP 1
            @L_TLOGMAPID=M.ID, 
            @L_OBJECTGUID=R.RQGUID 
         FROM 
            RQTLOGMAP               M, 
            RQPROJECTS              P, 
            RQPROJECTREQUIREMENTS   PR, 
            RQREQUIREMENTS          R 
         WHERE 
            P.RQGUID=@L_PRJGUID      AND 
            P.ID=PR.PROJECTID       AND 
            PR.REQUIREMENTID=R.ID   AND 
            R.RQGUID=M.OBJECTGUID   AND 
            M.EXTERNALID=@L_UNIQUEIDL1
      END
      
      IF (@L_OBJECTTYPE='RQPROJECTS') 
      BEGIN
         SELECT  TOP 1 @L_TLOGMAPID=ID FROM RQTLOGMAP WHERE OBJECTTYPE=@L_OBJECTTYPE AND OBJECTGUID=@L_PRJGUID AND EXTERNALID=@L_UNIQUEIDL1
         SET @L_OBJECTGUID=@L_PRJGUID
      END
      
      IF (@L_OBJECTTYPE='RQREQUIREMENTTYPES') 
      BEGIN
         SELECT 
            @L_TLOGMAPID=M.ID,
            @L_OBJECTGUID=T.RQGUID
         FROM 
            RQTLOGMAP                  M, 
            RQPROJECTS                 P, 
            RQPROJECTREQUIREMENTTYPES  PT, 
            RQREQUIREMENTTYPES         T
         WHERE 
            P.RQGUID=@L_PRJGUID         AND
            P.ID=PT.PROJECTID          AND
            PT.REQUIREMENTTYPEID= T.ID AND
            T.RQGUID=M.OBJECTGUID      AND
            M.EXTERNALID=@L_UNIQUEIDL1
      END
         
      IF (@L_OBJECTTYPE='RQUSERDEFINEDFIELDS')
      BEGIN
         SELECT
            @L_TLOGMAPID=M.ID,
            @L_OBJECTGUID=F.RQGUID
         FROM
            RQTLOGMAP                  M,
            RQTLOGMAP                  M1,
            RQPROJECTS                 P,
            RQPROJECTREQUIREMENTTYPES  PT,
            RQREQUIREMENTTYPES         T,
            RQREQUIREMENTTYPEFIELDS    TF,
            RQUSERDEFINEDFIELDS        F
         WHERE
            P.RQGUID=@L_PRJGUID        AND
            P.ID=PT.PROJECTID          AND
            PT.REQUIREMENTTYPEID= T.ID AND
            T.ID=TF.REQUIREMENTTYPEID  AND
            T.RQGUID=M1.OBJECTGUID     AND
            M1.EXTERNALID=@L_UNIQUEIDL2 AND
            TF.USERDEFINEDFIELDID=F.ID AND
            F.RQGUID=M.OBJECTGUID      AND
            M.EXTERNALID=@L_UNIQUEIDL1
      END
      
      IF (@L_OBJECTTYPE='RQUSERDEFINEDLISTITEMS')
      BEGIN
         SELECT
            @L_TLOGMAPID=M.ID,
            @L_OBJECTGUID=I.RQGUID
         FROM
            RQTLOGMAP                  M,
            RQTLOGMAP                  M1,
            RQTLOGMAP                  M2,
            RQPROJECTS                 P,
            RQPROJECTREQUIREMENTTYPES  PT,
            RQREQUIREMENTTYPES         T,
            RQREQUIREMENTTYPEFIELDS    TF,
            RQUSERDEFINEDFIELDS        F,
            RQUSERDEFINEDLISTITEMS     I
         WHERE
            P.RQGUID=@L_PRJGUID         AND
            P.ID=PT.PROJECTID          AND
            PT.REQUIREMENTTYPEID= T.ID AND
            T.ID=TF.REQUIREMENTTYPEID  AND
            T.RQGUID=M1.OBJECTGUID     AND
            M1.EXTERNALID=@L_UNIQUEIDL2 AND
            TF.USERDEFINEDFIELDID=F.ID AND
            F.ID=I.FIELDID             AND
            F.RQGUID=M2.OBJECTGUID     AND
            M2.EXTERNALID=@L_UNIQUEIDL3 AND
            I.RQGUID=M.OBJECTGUID      AND
            M.EXTERNALID=@L_UNIQUEIDL1
      END

   END
   
   ELSE IF   (@L_IDTYPE=1) -- the unique id is an RQGUID
   BEGIN
      SET @L_OBJECTGUID=@L_UNIQUEIDL1
      SELECT TOP 1 @L_TLOGMAPID=ID FROM RQTLOGMAP WHERE OBJECTTYPE=@L_OBJECTTYPE AND OBJECTGUID=@L_OBJECTGUID
   END

   if(@L_TLOGMAPID<>0) 
   BEGIN

      -- ##################################################################################################################
      -- ##################################################################################################################
      -- ##################################################################################################################
      IF (@L_OBJECTTYPE='RQREQUIREMENTS') 
      BEGIN

         -- First validate that the requirement belongs to the specified project.
         SELECT @L_REQID=R.ID FROM RQREQUIREMENTS R, RQPROJECTREQUIREMENTS PR, RQPROJECTS P WHERE R.ID=PR.REQUIREMENTID AND PR.PROJECTID=P.ID AND R.RQGUID=@L_OBJECTGUID AND P.RQGUID=@L_PRJGUID

         IF(@L_REQID<>0) 
         BEGIN

            -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTS
            DELETE FROM RQTLOGMAP WHERE ID=@L_TLOGMAPID

            -- Delete the RRC link in RQRESOURCES table (flags=2) for this requirement.
            -- Delete the RRC rich text in RQRESOURCES table (flags=1) for this requirement.
            DELETE FROM RQRESOURCES WHERE FLAGS IN (1,2) AND REQUIREMENTID=@L_REQID

            -- Set the non-text flag to OFF for this requirement, by turning off the 2nd bit in the respective RQREQUIREMENTS.FLAGS field.
            UPDATE RQREQUIREMENTS SET FLAGS=(FLAGS&(~(2))) WHERE RQGUID=@L_OBJECTGUID

         END

      END

      -- ##################################################################################################################
      -- ##################################################################################################################
      -- ##################################################################################################################
      IF (@L_OBJECTTYPE='RQPROJECTS' AND @L_OBJECTGUID=@L_PRJGUID) 
      BEGIN

         -- Delete all entries in RQTLOGPROPERTY for this project.
         DELETE FROM RQTLOGPROPERTY WHERE PROJECTGUID=@L_OBJECTGUID

         -- Delete the RRC link in RQRESOURCES table (flags=2) for this project.
         -- Delete the RRC rich text in RQRESOURCES table (flags=1) for this project.
         DELETE FROM RQRESOURCES WHERE ID IN (
            SELECT
               RS.ID
            FROM
               RQREQUIREMENTS             R,
               RQPROJECTREQUIREMENTS      PR,
               RQPROJECTS                 P,
               RQRESOURCES                RS,
               RQTLOGMAP                  M
            WHERE
               R.ID = PR.REQUIREMENTID    AND
               P.ID = PR.PROJECTID        AND
               R.ID = RS.REQUIREMENTID    AND
               RS.FLAGS IN(1,2)           AND
               M.OBJECTGUID=R.RQGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND
               M.OBJECTTYPE='RQREQUIREMENTS' 
         )
         
         -- Set the non-text flag to OFF for all requirements for this project, by turning off the 2nd bit in the respective RQREQUIREMENTS.FLAGS field.
         
         UPDATE RQREQUIREMENTS SET FLAGS=(FLAGS&(~(2))) WHERE ID IN (
            SELECT DISTINCT
               R.ID
            FROM
               RQREQUIREMENTS             R,
               RQPROJECTREQUIREMENTS      PR,
               RQPROJECTS                 P,
               RQTLOGMAP                  M
            WHERE
               R.ID = PR.REQUIREMENTID    AND
               P.ID = PR.PROJECTID        AND
               M.OBJECTGUID=R.RQGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND
               M.OBJECTTYPE='RQREQUIREMENTS' 
         )

         -- Remove entries in RqTLogMap table related to this project

         -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTTYPES
         DELETE FROM RQTLOGMAP WHERE ID IN (
            SELECT
               M.ID
            FROM
               RQTLOGMAP                  M,
               RQPROJECTS                 P,
               RQPROJECTREQUIREMENTTYPES  PT,
               RQREQUIREMENTTYPES         T
            WHERE
               P.ID=PT.PROJECTID          AND
               PT.REQUIREMENTTYPEID= T.ID AND
               T.RQGUID=M.OBJECTGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND 
               M.OBJECTTYPE='RQREQUIREMENTTYPES'
         )

         -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDFIELDS
         DELETE FROM RQTLOGMAP WHERE ID IN (
            SELECT
               M.ID
            FROM
               RQTLOGMAP                  M,
               RQPROJECTS                 P,
               RQPROJECTREQUIREMENTTYPES  PT,
               RQREQUIREMENTTYPES         T,
               RQREQUIREMENTTYPEFIELDS    TF,
               RQUSERDEFINEDFIELDS        F
            WHERE
               P.ID=PT.PROJECTID          AND
               PT.REQUIREMENTTYPEID= T.ID AND
               T.ID=TF.REQUIREMENTTYPEID  AND
               TF.USERDEFINEDFIELDID=F.ID AND
               F.RQGUID=M.OBJECTGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND
               M.OBJECTTYPE='RQUSERDEFINEDFIELDS'
         )

         -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDLISTITEMS
         DELETE FROM RQTLOGMAP WHERE ID IN (
            SELECT
               M.ID
            FROM
               RQTLOGMAP                  M,
               RQPROJECTS                 P,
               RQPROJECTREQUIREMENTTYPES  PT,
               RQREQUIREMENTTYPES         T,
               RQREQUIREMENTTYPEFIELDS    TF,
               RQUSERDEFINEDFIELDS        F,
               RQUSERDEFINEDLISTITEMS     I
            WHERE
               P.ID=PT.PROJECTID          AND
               PT.REQUIREMENTTYPEID= T.ID AND
               T.ID=TF.REQUIREMENTTYPEID  AND
               TF.USERDEFINEDFIELDID=F.ID AND
               F.ID=I.FIELDID             AND
               I.RQGUID=M.OBJECTGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND
               M.OBJECTTYPE='RQUSERDEFINEDLISTITEMS'
         )
         
         -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTS
         DELETE FROM RQTLOGMAP WHERE ID IN (
            SELECT
               M.ID
            FROM
               RQTLOGMAP                  M,
               RQPROJECTS                 P,
               RQPROJECTREQUIREMENTS      PR,
               RQREQUIREMENTS             R
            WHERE
               P.ID=PR.PROJECTID          AND
               PR.REQUIREMENTID= R.ID     AND
               R.RQGUID=M.OBJECTGUID      AND
               P.RQGUID=@L_OBJECTGUID      AND 
               M.OBJECTTYPE='RQREQUIREMENTS'
         )

         --  Turn sync flag OFF, if it is ON, for this project
         UPDATE RQPROJECTS SET FLAGS=(FLAGS&(~(64))) WHERE RQGUID=@L_OBJECTGUID

         -- Delete the entry in RQTLOGMAP for this project.
         DELETE FROM RQTLOGMAP WHERE OBJECTGUID=@L_OBJECTGUID
         
         -- Delete all current entries in RQTLOG for this project, related entries in RQTLOGCOLUMNS are deleted by cascade.
         DELETE FROM RQTLOG where PROJECTGUID=@L_OBJECTGUID

      END

      -- ##################################################################################################################
      -- ##################################################################################################################
      -- ##################################################################################################################
      IF (@L_OBJECTTYPE='RQREQUIREMENTTYPES') 
      BEGIN

         -- First validate that the requirement belongs to the specified project.
         SELECT @L_REQTYPEID=RT.ID FROM RQREQUIREMENTTYPES RT, RQPROJECTREQUIREMENTTYPES PRT, RQPROJECTS P WHERE RT.ID=PRT.REQUIREMENTTYPEID AND PRT.PROJECTID=P.ID AND P.RQGUID=@L_PRJGUID AND RT.RQGUID=@L_OBJECTGUID

         IF (@L_REQTYPEID<>0) 
         BEGIN

            -- Delete the RRC link in RQRESOURCES table (flags=2) for this requirement.
            -- Delete the RRC rich text in RQRESOURCES table (flags=1) for this requirement.
            DELETE FROM RQRESOURCES WHERE FLAGS IN (1,2) AND ID IN (
               SELECT
                  RS.ID
               FROM
                  RQREQUIREMENTS             R,
                  RQPROJECTREQUIREMENTS      PR,
                  RQPROJECTS                 P,
                  RQRESOURCES                RS,
                  RQTLOGMAP                  M,
                  RQREQUIREMENTTYPES         RT 
               WHERE
                  R.ID = PR.REQUIREMENTID    AND
                  PR.PROJECTID = P.ID        AND
                  P.RQGUID=@L_PRJGUID         AND
                  R.ID = RS.REQUIREMENTID    AND
                  RS.FLAGS IN(1,2)           AND
                  M.OBJECTGUID=R.RQGUID      AND
                  RT.ID=R.REQUIREMENTTYPEID  AND
                  RT.RQGUID=@L_OBJECTGUID     AND
                  M.OBJECTTYPE='RQREQUIREMENTS'
            )

            -- Set the non-text flag to OFF for this requirement, by turning off the 2nd bit in the respective RQREQUIREMENTS.FLAGS field.
            UPDATE RQREQUIREMENTS SET FLAGS=(FLAGS&(~(2))) WHERE ID IN 
            (
               SELECT R.ID 
               FROM 
                  RQREQUIREMENTS             R, 
                  RQREQUIREMENTTYPES         RT,
                  RQTLOGMAP                  M
               WHERE 
                  RT.ID=R.REQUIREMENTTYPEID  AND 
                  RT.RQGUID=@L_OBJECTGUID     AND
                  M.OBJECTGUID=R.RQGUID      AND
                  M.OBJECTTYPE='RQREQUIREMENTS'
            )

            -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTTYPES
            DELETE FROM RQTLOGMAP WHERE ID IN (
               SELECT
                  M.ID
               FROM
                  RQTLOGMAP                  M,
                  RQPROJECTS                 P,
                  RQPROJECTREQUIREMENTTYPES  PT,
                  RQREQUIREMENTTYPES         T
               WHERE
                  P.ID=PT.PROJECTID          AND
                  PT.REQUIREMENTTYPEID= T.ID AND
                  T.RQGUID=M.OBJECTGUID      AND
                  M.OBJECTGUID=@L_OBJECTGUID  AND
                  M.OBJECTTYPE='RQREQUIREMENTTYPES'
            )

            -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDFIELDS
            DELETE FROM RQTLOGMAP WHERE ID IN (
               SELECT
                  M.ID
               FROM
                  RQTLOGMAP                  M,
                  RQPROJECTS                 P,
                  RQPROJECTREQUIREMENTTYPES  PT,
                  RQREQUIREMENTTYPES         T,
                  RQREQUIREMENTTYPEFIELDS    TF,
                  RQUSERDEFINEDFIELDS        F
               WHERE
                  P.ID=PT.PROJECTID          AND
                  PT.REQUIREMENTTYPEID= T.ID AND
                  T.ID=TF.REQUIREMENTTYPEID  AND
                  TF.USERDEFINEDFIELDID=F.ID AND
                  F.RQGUID=M.OBJECTGUID      AND
                  T.RQGUID=@L_OBJECTGUID      AND
                  M.OBJECTTYPE='RQUSERDEFINEDFIELDS'
            )

            -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDLISTITEMS
            DELETE FROM RQTLOGMAP WHERE ID IN (
               SELECT
                  M.ID
               FROM
                  RQTLOGMAP                  M,
                  RQPROJECTS                 P,
                  RQPROJECTREQUIREMENTTYPES  PT,
                  RQREQUIREMENTTYPES         T,
                  RQREQUIREMENTTYPEFIELDS    TF,
                  RQUSERDEFINEDFIELDS        F,
                  RQUSERDEFINEDLISTITEMS     I
               WHERE
                  P.ID=PT.PROJECTID          AND
                  PT.REQUIREMENTTYPEID= T.ID AND
                  T.ID=TF.REQUIREMENTTYPEID  AND
                  TF.USERDEFINEDFIELDID=F.ID AND
                  F.ID=I.FIELDID             AND
                  I.RQGUID=M.OBJECTGUID      AND
                  T.RQGUID=@L_OBJECTGUID      AND
                  M.OBJECTTYPE='RQUSERDEFINEDLISTITEMS'
            )

            -- DELETE THE RQTLOGMAP RECORDS FOR RQREQUIREMENTS
            DELETE FROM RQTLOGMAP WHERE ID IN (
               SELECT
                  M.ID
               FROM
                  RQTLOGMAP                  M,
                  RQPROJECTS                 P,
                  RQPROJECTREQUIREMENTS      PR,
                  RQREQUIREMENTS             R,
                  RQREQUIREMENTTYPES         RT
               WHERE
                  P.ID=PR.PROJECTID          AND
                  PR.REQUIREMENTID= R.ID     AND
                  R.RQGUID=M.OBJECTGUID      AND
                  RT.ID=R.REQUIREMENTTYPEID  AND
                  RT.RQGUID=@L_OBJECTGUID     AND
                  M.OBJECTTYPE='RQREQUIREMENTS'
            )

         END

      END

      -- ##################################################################################################################
      -- ##################################################################################################################
      -- ##################################################################################################################
      IF (@L_OBJECTTYPE='RQUSERDEFINEDFIELDS') 
      BEGIN
      
         -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDLISTITEMS
         DELETE FROM RQTLOGMAP WHERE ID IN (
            SELECT
               M.ID
            FROM
               RQTLOGMAP                  M,
               RQPROJECTS                 P,
               RQPROJECTREQUIREMENTTYPES  PT,
               RQREQUIREMENTTYPES         T,
               RQREQUIREMENTTYPEFIELDS    TF,
               RQUSERDEFINEDFIELDS        F,
               RQUSERDEFINEDLISTITEMS     I
            WHERE
               P.ID=PT.PROJECTID          AND
               PT.REQUIREMENTTYPEID= T.ID AND
               T.ID=TF.REQUIREMENTTYPEID  AND
               TF.USERDEFINEDFIELDID=F.ID AND
               F.ID=I.FIELDID             AND
               I.RQGUID=M.OBJECTGUID      AND
               F.RQGUID=@L_OBJECTGUID
         )

         -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDFIELDS
         DELETE FROM RQTLOGMAP WHERE ID=@L_TLOGMAPID

      END

      -- ##################################################################################################################
      -- ##################################################################################################################
      -- ##################################################################################################################
      IF (@L_OBJECTTYPE='RQUSERDEFINEDLISTITEMS') 
      BEGIN
         -- DELETE THE RQTLOGMAP RECORDS FOR RQUSERDEFINEDLISTITEMS
         DELETE FROM RQTLOGMAP WHERE ID=@L_TLOGMAPID
         
      END

   END

END
GO




-- Update flag for integration completion
UPDATE RQREQUISITE SET RESERVEDFLAGS=RESERVEDFLAGS|2